local msg = function(M) reaper.ShowConsoleMsg(tostring(M).."\n") end
--------------------------------------------------------------------------------
-- time_start = reaper.GetCursorPosition()
a = 2 -- расстояние между регионами
next_start_item = 0

function TimeStartChange()
  local time_start_n = reaper.GetPlayPosition()
  if time_start_n ~= time_start then time_start = time_start_n
    return true
  end
end

function MasteringTrack()
  reaper.Main_OnCommand(40342,0) -- Track: Bypass FX on all tracks
  reaper.Main_OnCommand(40297,0) -- Track: Unselect all tracks
  local mastertrack = reaper.GetMasterTrack(0)
  reaper.SetMediaTrackInfo_Value(mastertrack, "I_FXEN", 1) -- анбайпас на Мастер треке
  local Sitem = reaper.GetSelectedMediaItem( 0, 0 )
  local Strack = reaper.GetMediaItemTrack( Sitem )
  if Strack then
    reaper.SetTrackSelected(Strack, 1)
    reaper.SetMediaTrackInfo_Value(Strack, "I_FXEN", 1)
  end
  local counttracks = reaper.CountTracks(0)
  for i = 1, counttracks do
    local track = reaper.GetTrack(0, i-1)
    local item = reaper.GetTrackMediaItem(track, 0)
    if item == nil then
      reaper.SetMediaTrackInfo_Value(track, "I_FXEN", 1) -- анбайпас на треке без айтемов
    end
  end
end

function SelRegion()
  local time_start = reaper.GetPlayPosition()
  local CountAllMarkers = ({reaper.CountProjectMarkers(0)})[2]+({reaper.CountProjectMarkers(0)})[3]
  local CountRegionMarkers = ({reaper.CountProjectMarkers(0)})[3]
  if CountRegionMarkers == 0 then return end
  for i=1, CountAllMarkers do
    local RegionMarkers = ({reaper.EnumProjectMarkers(i-1)})[2]
    if RegionMarkers == true then
      local startRegion = ({reaper.EnumProjectMarkers(i-1)})[3]
      local endRegion = ({reaper.EnumProjectMarkers(i-1)})[4]
      if time_start>=startRegion and time_start<= endRegion then
        reaper.GetSet_LoopTimeRange(1, 0, startRegion, endRegion, 0)
        reaper.Main_OnCommand(40717,0) -- Item: Select all items in current time selection
      end
    end
  end
  MasteringTrack()
end

function mainloop()
  if TimeStartChange() then
    reaper.TrackList_AdjustWindows(false) -- проект изменился - делает рефреш GUI
    SelRegion()
  end
  reaper.defer(mainloop)
end

----------------------------------------------------------------------------------------
function StartMastering()
  local CountRegionMarkers = ({reaper.CountProjectMarkers(0)})[3]
  if CountRegionMarkers == 0 then
    local counttracks = reaper.CountTracks(0)
    for i = 1, counttracks do
      local track = reaper.GetTrack(0, i-1)
      local _, name = reaper.GetTrackName(track)
      local item = reaper.GetTrackMediaItem(track, 0)

      if item then
        item_start = next_start_item
        reaper.SetMediaItemPosition(item, item_start, true)
        local item_end = item_start + reaper.GetMediaItemInfo_Value(item, "D_LENGTH")
        reaper.AddProjectMarker(0, true, item_start, item_end, name, 1)
        reaper.Main_OnCommand(40839,0) -- Move edit cursor forward one measure (no seek)
        next_start_item = math.floor(item_end)+a
      end
    end
  end
  reaper.TrackList_AdjustWindows(false) -- проект изменился - делает рефреш GUI

  SelRegion()
  mainloop()
end

-----------------------------------------------------------------------------------------
-- Set ToolBar Button ON
function SetButtonON()
  is_new_value, filename, sec, cmd, mode, resolution, val = reaper.get_action_context()
  state = reaper.GetToggleCommandStateEx( sec, cmd )
  reaper.SetToggleCommandState( sec, cmd, 1 ) -- Set ON
  reaper.RefreshToolbar2( sec, cmd )
end
--
-- Set ToolBar Button OFF
function SetButtonOFF()
  is_new_value, filename, sec, cmd, mode, resolution, val = reaper.get_action_context()
  state = reaper.GetToggleCommandStateEx( sec, cmd )
  reaper.SetToggleCommandState( sec, cmd, 0 ) -- Set OFF
  reaper.RefreshToolbar2( sec, cmd )
end
----------------------------------------------------------------------------------------

-- RUN
SetButtonON()
StartMastering()
reaper.atexit( SetButtonOFF )
